/*****************************
* Source : acloneTest.prg
* System : <unkown>
* Author : Phil Ide
* Created: 28/01/2004
*
* Purpose:
* ----------------------------
* History:
* ----------------------------
*    28/01/2004 11:22 PPI - Created
*****************************/

#include "Common.ch"
#include "directry.ch"
//#include "simpleio.ch"

#define HRTEST_COUNT 500
#define BIT_MASK     0x20
#define TEST_COUNT   2
#define MANTISSA     13
#define REAL         15

Proc Main( cDir )
   local o := HRTimer():new()
   local aRet := {}
   local aTest
   local x
   local aDirectory
   local aNewDirectory

   default cDir to 'c:\idep\xbase\'

   if cDir[-1] <> '\'
      cDir += '\'
   endif

   aDirectory := LoadDirectory( cDir )
   aNewDirectory := Array( Len(aDirectory) )

   x := 0
   ? '# Elements:', ArrayCount(aDirectory, @x)
   ? '# Sub-Els :', x

   o:start()
   AContentCopy(aNewDirectory, aDirectory)
   o:stop()
   ? 'Duration:', Str( o:duration, REAL, MANTISSA ), 'AEval ', 'Avg:', Str( o:duration/x, REAL, MANTISSA )

   aNewDirectory := NIL
   sleep(5) // let GC tidy up
   aNewDirectory := Array( Len(aDirectory) )
   
   o:start()
   AContentCopy2(aNewDirectory, aDirectory)
   o:stop()
   ? 'Duration:', Str( o:duration, REAL, MANTISSA ), 'AClone', 'Avg:', Str( o:duration/x, REAL, MANTISSA )
   ?
   ?
   return

Function ArrayCount(a, nSub)
   local n := Len(a)
   local i

   for i := 1 to len(a)
      if ValType(a[i]) = 'A'
         n += ArrayCount(a[i], @nSub)
         nSub++
      endif
   next
   return n

Function LoadDirectory( cDir )
   local aRet := Directory( cDir+'*.*', 'D' )
   local i

   for i := 1 to Len( aRet )
      if 'D' $ aRet[i][F_ATTR] .and. !(aRet[i][F_NAME] == '.' .or. aRet[i][F_NAME] == '..')
         aRet[i] := LoadDirectory( cDir+aRet[i][F_NAME]+'\' )
      endif
   next
   return aRet


STATIC FUNCTION  AElementCopy(xAtom,nIndex,aSrc)

   IF nIndex > LEN(aSrc)                           // nothing to copy
   ELSEIF valtype(xAtom) = 'A'       // array? recurse
      IF valtype(aSrc[nIndex]) = 'A'     // source must match or we do nothing
         AContentCopy(aSrc[nIndex], xAtom)
      ENDIF
   ELSEIF aSrc[nIndex] <> NIL        // don't copy NIL values
      xAtom := aSrc[nIndex]
   ENDIF

   RETURN NIL

FUNCTION AContentCopy(aSrc, aDst)

   AEVAL(aDst,   {|xAtom,nIndex| AElementCopy(@xAtom,nIndex,aSrc)},,,.T.)

   RETURN aDst

STATIC FUNCTION  AElementCopy2(xAtom,nIndex,aSrc)

   IF nIndex > LEN(aSrc)                           // nothing to copy
   ELSEIF valtype(xAtom) = 'A'       // array? recurse
      IF valtype(aSrc[nIndex]) = 'A'     // source must match or we do nothing
         AContentCopy2(aSrc[nIndex], xAtom)
      ENDIF
   ELSEIF aSrc[nIndex] <> NIL        // don't copy NIL values
      xAtom := aSrc[nIndex]
   ENDIF

   RETURN NIL

FUNCTION AContentCopy2(aSrc, aDst)
   aDst := AClone( aSrc )
   RETURN aDst
